###################################################################
#  GTChat 0.96 Alpha Plugin                                       #
#  Written for release 20040124                                   #
#  Author: The GTChat Developer Team                              #
#                                                                 #
#  This plugin integrates the GTChat 0.96 in a WBBLite            #
###################################################################
package GTChat::Plugins::ExternalLink::096_01;
use strict;
use DBI;

return bless({});

sub getEnvironment
{
	my ($self, $main, $environment) = @_;

	my $external_user = getExternalLogin();
	if (defined($external_user))
	{
		unless ($environment->{has_uncrypted_password})
		{
			$environment->{name} = $external_user->{name};
			$environment->{is_username} = 1;
			$environment->{has_password} = $self;
		}
	}
}

sub checkPassword
{
	return 1;
}

sub generateUser
{
	my ($self, $main, $user) = @_;

	my $external_user = getExternalUser($user->{name});

	if (defined($external_user))
	{
		$external_user->{password} = '';

		$main->{runtime}{allow_registration} = 1;

		$main->addUser($external_user);

		return $main->loadUser($external_user->{name});
	}
	else
	{
		return undef;
	}
}

sub cleanUp
{

}

sub checkLogin
{
	my($self,$main,$user,$room) = @_;

	my $external_user = getExternalUser($user->{name});

	foreach my $key (keys %$external_user)
	{
		$user->{$key} = $external_user->{$key};
	}

	foreach (keys %{$main->{settings}{default}})
	{
		$user->{$_} = $main->{settings}{default}{$_} unless exists($user->{$_});
	}

	$user->{registration} = $main->{runtime}{now} unless exists($user->{registration});
}

sub checkProfile
{
	my ($self,$main,$user,$olduser) = @_;

	if (!defined($olduser) && !$main->{runtime}{allow_registration})
	{
		$main->fatal_error('nopermission');
	}
}

sub getExternalLogin
{
	my $user = {};

	my %info = {};
	foreach (split(/&/,$ENV{'QUERY_STRING'}))
	{
		my ($v,$i) = split(/=/,$_);
		$v =~ tr/+/ /;
		$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$i =~ tr/+/ /;
		$i =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$i =~ s/<!--(.|\n)*-->//g;
		$info{$v} = $i;
	}

	my $sid = $info{'sid'};

	if($sid)
	{
		$sid =~ s/\W//g;

		my $db_name = "DBI:mysql:XXX"; 		#Datenbankname
		my $db_user = "YYY"; 			#Datenbank-Username
		my $db_pass = "ZZZ"; 			#Datenbank-Passwort
		my @ergebnis;
		my $id;

		my $dbh = DBI->connect("$db_name","$db_user","$db_pass") || die "Database connection not made: $DBI::errstr";
		my $sql = qq{select * from bbX_sessions where hash = '$sid'};
		my $sth = $dbh->prepare($sql);

		$sth->execute();

		while(@ergebnis=$sth->fetchrow_array)
		{
			$id = $ergebnis[1];
		}

		$sth->finish();

		if($id)
		{
			my $sql = qq{select * from bbX_users where userid = '$id'};
			my $sth = $dbh->prepare($sql);
			$sth->execute();
			while(@ergebnis=$sth->fetchrow_array)
			{
				$user->{name} = $ergebnis[1];
				
			}

			$sth->finish();

			$dbh->disconnect();

			return $user;
		}
	}

	return undef;
}

sub getExternalUser
{
	my $username = shift;

	my $user = {};
	
	if($username)
	{
		my $db_name = "DBI:mysql:XXX"; 		#Datenbankname
		my $db_user = "YYY"; 			#Datenbank-Username
		my $db_pass = "ZZZ"; 			#Datenbank-Passwort
		my @ergebnis;

		my $dbh = DBI->connect("$db_name","$db_user","$db_pass") || die "Database connection not made: $DBI::errstr";
		my $sql = qq{select * from bbX_users where username = '$username'};
		my $sth = $dbh->prepare($sql);

		$sth->execute();

		while(@ergebnis=$sth->fetchrow_array)
		{
			$user->{name} = $username;
			$user->{nick} = $ergebnis[1];
			$user->{email} = $ergebnis[4];
		}

		$sth->finish();
		$dbh->disconnect();

		return $user;
	}

	return undef;
}